<template>
  <div class="scheduler-settings">
    <scheduler-modal-content
        @savePlan="savePlan"
        @closeModal="modalClosed"
        @startRecalculate="startRecalculate"
        @isSubmitStatus="isSubmitStatus"
        :recalculateSubmitText="recalculateSubmitText"
        v-model="plan"
        :recalculateDisabled="recalculateDisabled"
        :startValue="startValue"
        :isSubmitDisabled="isSubmitDisabled"
    />
  </div>
</template>


<script>
  import api from '@/api';
  import SchedulerModalContent from './SchedulerModal';

  export default {
    name: 'SchedulerModal',
    components: {
      SchedulerModalContent,
    },
    data() {
      return {
        modalId: 0,
        plan:{
          weekDay: null,
          startTime: null,
        },
        startValue: null,
        recalculateDisabled: true,
        isSubmitDisabled: true,
        recalculateSubmitText: 'Идет перерасчет базовых цен...'
      };
    },
    async created() {
      await this.openSchedulerModal();
    },
    methods: {
      async openSchedulerModal(){
        const recalculateStatus = await api.base_prices.getRecalculateStatus();
        if(!recalculateStatus.execute){
          this.recalculateDisabled = false
          this.recalculateSubmitText = 'Пересчитать сейчас'
        }

        try {
          const currentPlan = await api.base_prices.getCurrentPlan();
          this.plan = {
            weekDay: currentPlan.weekDay,
            startTime: currentPlan.startTime.substring(0, 5),
          };
          this.startValue = {...this.plan};
          this.isSubmitDisabled = true;
          // this.$refs.scheduler.open();
        } catch {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных',
          });
        }

      },
      modalClosed(){
        // this.$refs.scheduler.cancel();
      },
      async savePlan(){
        try {
          await api.base_prices.updateScheduling(this.plan);
          this.modalClosed()
        } catch {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка отправки данных',
          });
        }
      },
      async startRecalculate(){
        try {
          let res = await api.base_prices.startGlobalRecalculate();
          this.modalClosed();
          setTimeout(()=>{
            this.$notification({
              type: 'system_notification_success',
              message: res.comments
            });
          }, 500)
        } catch {
          this.$notification({
            type: 'system_notification_error',
            message: 'Не удалось запустить перерасчет',
          });
        }
      },
      isSubmitStatus(status){
        this.isSubmitDisabled = status
      }
    }
  }
</script>

<style scoped lang="scss">
.scheduler-settings{
  padding: 30px 20px;
}
</style>
